/* hanoi.c  19-Nov-88  Modified by A.J.Travis */

/*
 * Towers of Hanoi in Small-C by Jon Welch
 * ---------------------------------------
 * The program should be run in mode 2, and
 * shows the disks in 7 different colours.
 * mode() added J.G.Harston, 01-Jul-90.
 */

#include <stdio.h>

int j, n;
int one, two, three;

int main()
{
       mode(2);
	printf("\f\nHeight (0-12): ");
	scanf("%d", &n);
	if (n > 12)
		n = 12;
	j = n;
	while (j > 0) {
		box((j % 7) + 1, 200, (n - j + 1) * 40, j * 16);
		j = j - 1;
	}
	one = n * 40;
	two = 0;
	three = 0;
	hanoi(n, 1, 2, 3);
	exit(0);
}

up(x)
int x;
{
	if (x == 1)
		one = one + 40;
	else if (x == 2)
		two = two + 40;
	else
		three = three + 40;
}

down(x)
int x;
{
	if (x == 1)
		one = one - 40;
	else if (x == 2)
		two = two - 40;
	else
		three = three - 40;
}

height(x)
int x;
{
	if (x == 1)
		return(one);
	else if (x == 2)
		return(two);
	else
		return(three);
}

bytes(x)
int x;
{
	vdu(x);
	vdu(x >> 8);
}

box(col, x, y, size)
int col, x, y, size;
{
	vdu(18);
	vdu(0);
	vdu(col + 128);
	vdu(24);
	bytes(x - size);
	bytes(y);
	bytes(x + size);
	bytes(y + 20);
	vdu(16);
}

move(n, s, e)
int n, s, e ;
{
	box(0, s * 400 - 200, height(s), n * 16);
	down(s);
	up(e);
	box((n % 7) + 1, e * 400 - 200, height(e), n * 16);
}

hanoi(a, b, c, d)
int a, b, c, d;
{
	if (a != 0) {
		hanoi(a - 1, b, d, c);
		move(a, b, c);
		hanoi(a - 1, d, c, b);
	}
}

mode(a)
int a;
{
if (osbyte(130,0) < 0 & osbyte(133,a | 0x80)-osbyte(132,0) < 0) {
  printf("Restart in mode %d.\n",a);
  exit(1);	/* If not in tube, and no memory for mode change, stop */
  }
vdu(22); vdu(a | 0x80);
}
