/* plot.c  19-Nov-88  Modified by A.J.Travis */

/*
 * recursive boxes in Small-C by Jon Welch
 * ---------------------------------------
 * The plot program should be run in graphics mode 1.
 * mode() added by J.G.Harston 01-Jul-90
 */

#include <stdio.h>

#define N 6
#define H0 1024

int h,x0,y0,x,y,loop;

int main()
{
        init();
	 mode(1);
        for (loop=1;loop<=N;loop++) {
                vdu(18);
                vdu(0);
                vdu(loop % 3+1);
                xyset();
                sides(loop,0);
        }
	exit(0);
}

mode(a)
int a;
{
if (osbyte(130,0) < 0 & osbyte(133,a | 0x80)-osbyte(132,0) <0 ) {
  printf("Restart in mode %d.\n",a);
  exit(1);	/* If not in tube, and no memory for mode change, stop */
  }
        vdu(22);
        vdu(a | 0x80);
}

plot(k,x,y)
int k,x,y;
{
        vdu(25);
        vdu(k);
        vdu(x);
        vdu(x >> 8);
        vdu(y);
        vdu(y >> 8);
}

addx()
{
        x=x+h;
        plot(5,x,y);
}

subx()
{
        x=x-h;
        plot(5,x,y);
}

addy()
{
        y=y+h;
        plot(5,x,y);
}

suby()
{
        y=y-h;
        plot(5,x,y);
}

or1(a)
int a;
{
        sides(a,3);  subx();
        sides(a,0);  suby();
        sides(a,0);  addx();
        sides(a,1);
}

or2(a)
int a;
{
        sides(a,2);  addy();
        sides(a,1);  addx();
        sides(a,1);  suby();
        sides(a,0);
}

or3(a)
int a;
{
        sides(a,1);  addx();
        sides(a,2);  addy();
        sides(a,2);  subx();
        sides(a,3);
}

or4(a)
int a;
{
        sides(a,0);  suby();
        sides(a,3);  subx();
        sides(a,3);  addy();
        sides(a,2);
}

sides(a,b)
int a,b;
{
        if (a != 0) {
                a=a-1;
                if (b==0) or1(a);
                else if (b==1) or2(a);
                else if (b==2) or3(a);
                else or4(a);
        }
}

init()
{
        h=H0;
        x0=h / 2;
        y0=h / 2;
}

xyset()
{
        h=h / 2;
        x0=x0+h / 2;
        y0=y0+h / 2;
        x=x0;
        y=y0;
        plot(4,x,y);
}
