/* sfa.c - 11 Apr 88  A.J.Travis */

/*
 * Set File Attributes for BBC Micro DFS/ADFS binaries
 */

#include <stdio.h>

#define W_CAT 1				/* write MOS catalogue info */
#define RW 3				/* read/write attributes */
#define LOAD 0x1902			/* default load address */
#define EXEC 0x1902			/* default exec address */

int main(argc, argv)
int argc;
char *argv[];
{
	int *fcb[9];	/* file control block */

	if (argc != 2)
		usage();
	if (stat(argv[1], fcb) == -1) {
		fprintf(stderr, "sfa: %s not found\n", argv[1]);
		exit(-1);
	}
	fcb[0] = 0;
	fcb[1] = LOAD;
	fcb[2] = 0;
	fcb[3] = EXEC;
	fcb[4] = 0;
	fcb[5] = 0;
	fcb[6] = 0;
	fcb[7] = RW;
	fcb[8] = 0;
	osfile(argv[1], fcb, W_CAT);
	exit(0);
}

/*
 * report correct usage and exit
 */
usage()
{
	fprintf(stderr, "usage: sfa file\n");
	exit(-1);
}
