; swcrt.s  22-Apr-89  A.J.Travis

;
; startup code for tcc run-time support
; in user sideways ROM/RAM area above $8000
;

; 23-Jun-1991  v0.71 - J.G.Harston
;   ~restart-1 pushed onto machine stack instead of ~restart
;   prints with osasci instead of oswrch

	*=osurom
;
	evs = tr		;pointer to extended vector space
	ebrkv = $ff03		;extended break vector
	eevntv = $ff30		;extended event vector
;
; language entry
;
	jmp ~lang
;
; service entry
;
	jmp ~serv
;
; ROM type (service and language entry)
;
	.byte %11000010
;
; copyright offset pointer
;
	.byte ~cpmess - osurom - 1
;
; binary version number
;
	.byte 07
;
; title string
;
~title
	.text "Small-C"
	.byte 0
;
; version string
;
~version
	.text "0.72"
	.text " (23 Jun 1991)"
	.byte 0
;
; copyright message
;
~cpmess
	.text "(C)1989 A.J.Travis"
	.byte 0
;
; Small-C command shell help
;
~helpmess
	.text "NAME"
	.byte $0d
	.text "    sh - Small-C command shell"
	.byte $0d,$0d
	.text "SYNOPSIS"
	.byte $0d
	.text "    *"
;
; Small-C command shell name
~shell
	.text "sh"
	.byte $0d,$0d
	.text "DESCRIPTION"
	.byte $0d
	.text "    Sideways ROM/RAM version of Small-C"
	.byte $0d
	.text "    run-time support, and tcc library."
	.byte $0d
	.text "    *sh invokes an interactive shell."
	.byte $0d,$0d
	.text "AUTHOR"
	.byte $0d
	.text "    A.J.Travis"
	.byte $0d,$00
;
; check service call
;
~serv
	pha		;save registers
	tya
	pha
	txa
	pha
;
	tsx
	lda $103,x	;service type requested
	cmp #$04	;unrecognised command?
	bne ~qhelp
;
; scan MOS command line for name of Small-C command shell
; -------------------------------------------------------
; exit with registers preserved if not selected
;
~qshell
	ldx #$00
~scan2
	lda ~shell,x
	cmp ($f2),y
	beq ~scan3
	eor #$20
	cmp ($f2),y
	bne ~notme
~scan3
	cmp #$0d
	beq ~startup
	iny
	inx
	jmp ~scan2
~notme
	jmp ~out
;
; start up language
;
~startup
	lda #$8e	;start language
	ldx osrom	;current ROM id
	jmp osbyte
;
; check for *help [sh]
;
~qhelp
	cmp #$09	;*help request?
	bne ~notme
	jsr osnewl
	lda ($f2),y	;*help <null> ?
	cmp #$0d
	bne ~morehelp
	ldx #0
~help1
	lda ~title,x	;print ROM title
	beq ~help2
	jsr oswrch
	inx
	jmp ~help1
~help2
	lda #$20	;space
	jsr oswrch
	ldx #0
~help3
	lda ~version,x	;print ROM version
	beq ~help4
	cmp #$20
	beq ~help4
	jsr oswrch
	inx
	jmp ~help3
~help4
	jsr osnewl
	lda #$20	;space
	jsr oswrch
	jsr oswrch
	ldx #0
~help5
	lda ~shell,x	;print help prompt
	jsr osasci
	inx
	cmp #$0d
	bne ~help5
	jmp ~out
;
; expand Small-C command shell help if requested
;
~morehelp
	ldx #0
~scan4
	lda ~shell,x
	cmp #$0d
	beq ~dohelp
	cmp ($f2),y
	beq ~scan5
	eor #$20
	cmp ($f2),y
	bne ~out
~scan5
	iny
	inx
	jmp ~scan4
~dohelp
	ldy #0
	lda #<~helpmess
	sta tr
	lda #>~helpmess
	sta tr + 1
~help7
	lda (tr),y
	beq ~help8
	jsr osasci
	inc tr
	bne ~help7
	inc tr + 1
	jmp ~help7
~help8
	jsr osnewl
~complete
	tsx
	lda #0		;stop further processing
	sta $103,x	;clobber service request
~out
	pla		;restore registers and exit
	tax
	pla
	tay
	pla
	rts
;
; language entry point
; --------------------
; initialise sp (data stack pointer)
; and enter command shell
;
~lang
~restart
	lda #$a8	;get extended vector space
	ldx #$00
	ldy #$ff
	jsr osbyte	;returns evs in xy
	stx evs
	sty evs + 1
;
	ldy #3		;brkv = vector #1 * 3
	lda #<break	;address of Small-C BRK handler
	sta (evs),y
	iny
	lda #>break
	sta (evs),y
	iny
	lda osrom	;current ROM id
	sta (evs),y
;
	ldy #48		;evntv = vector #16 * 3
	lda #<escape	;address of Small-C escape handler
	sta (evs),y
	iny
	lda #>escape
	sta (evs),y
	iny
	lda osrom	;current ROM id
	sta (evs),y
;
	lda #<ebrkv	;set up BRK vector
	sta brkv
	lda #>ebrkv
	sta brkv+1
	lda #<eevntv	;set up escape vector
	sta evntv
	lda #>eevntv
	sta evntv+1
;
; warm start
;
; was ~restart
	lda #14		;enable escape event
	ldx #6
	jsr osbyte
	cli		;enable interrupts
	cld
	ldx #$ff	;initialise return stack
	txs
	lda #>~restart-1 ;place return addr on stack
	pha
	lda #<~restart-1
	pha
	tsx
	stx rsp		;save value of return stack pointer
	lda #$84	;read bottom of display RAM
	jsr osbyte
	stx sp
	sty sp+1
	jmp __enter	;user entry point
;
; BRK handler
;
break
	ldy #1		;offset to start of message
~break1
	lda ($fd),y	;error message pointer = $fd,$fe
	beq ~break2	;null terminated message
	jsr oswrch
	iny
	jmp ~break1	
~break2
	jsr osnewl
	jmp ~lang	;cold start
;
